package quotes.local;

import java.util.Enumeration;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JTextArea;

import quotes.ChannelC;

/**
 * @author delpiano
 *
 * A simple viewer of bufferized content.
 */
public class TextLogBufferViewer extends JTextArea implements Observer {

	/** A simple Observer implemented as a Swing text area.*/
	public TextLogBufferViewer() {
		super();
	}

	/**
	 * @see java.util.Observer#update(Observable, Object)
	 */
	public void update(Observable o, Object arg) {
		
		if (!(o instanceof BufferedSubscriber)) { return; }
		
		BufferedSubscriber sbscbr = (BufferedSubscriber) o;
		
		StringBuffer str_bff = new StringBuffer();
		for (Enumeration enum = sbscbr.getChannels() ; enum.hasMoreElements() ;) {
			ChannelC chnnl = (ChannelC) enum.nextElement();
			for (int i = 0 ; i < sbscbr.getBufferSize() ; i++) {
				str_bff.append(chnnl.getName());
				str_bff.append(": ");
				str_bff.append(sbscbr.getBufferedValue(chnnl , i));
				str_bff.append("\n");
			}
		}
		setText(str_bff.toString());
	}

}
